; Don't draw the surface cursor.
<403077>
	pop	edi
	pop	esi
	pop	ebx
	ret	8

; Don't set the window cursor.
<404046> db	1E

; Exit immediately.
<405b05> dd	0

; Create a centered 800x600 window, remembering the top-left corner.
<405E85..405ed8>
	push    600.
	push    800.
	push	1		;; SM_CYSCREEN
	call	esi		;; GetSystemMetrics
	sub	eax,600.
	shr	eax,1
	push	eax
	mov	[@y],eax
	push    ebx		;; SM_CXSCREEN
	call	esi		;; GetSystemMetrics
	sub	eax,800.
	shr	eax,1
	push	eax
	mov	[@x],eax
	push    80000000	;; WS_POPUP
	push    4146E4
	push    4146E4
	push    ebx		;; no extended style (not on top)
	call	dword[412174]	;; CreateWindowEx
	cmp	eax,ebx
	mov	[417748],eax
	jne	short 405ed8
	jmp	40640e 

; Enable Aero compatibility and create as a normal window.
<405ef4>
	push	@zSetAppCompatData
	push	@zDDraw
	call	dword[41208c]	;; GetModuleHandle
	push	eax
	call	dword[4120e8]	;; GetProcAddress
	test	eax,eax
	jz	short @f
	push	0
	push	2
	call	eax		;; enable Aero compatibility
@@:	lea     eax,[esp+10]
	push    ebx
	push    eax
	push    ebx
	call    4083C0		;; DirectDrawCreate
	cmp     eax,ebx
	jne     4063E5
	mov     eax,[esp+10]
	push    41C8EC
	push    4121AC
	push    eax
	mov     ecx,[eax]
	call    dword[ecx]	;; QueryInterface
	cmp     eax,ebx
	jne     4063E5
	mov     eax,[41C8EC]
	mov     ecx,[417748]
	push    8		;; DDSCL_NORMAL
	push    ecx
	mov     edx,[eax]
	push    eax
	call    dword[edx+50]	;; SetCooperativeLevel
	test    eax,eax
	je      short 405Fb7
	jmp	405fa9

<405fe6> db	01		;; DDSD_CAPS
<405ff1> db	00		;; DDSCAPS_PRIMARYSURFACE

; Create an offscreen surface.
<40600c..40604d>
	push	ebx
	lea	edx,[esp+98]
	mov	dword[edx],7C
	mov	dword[edx+4],07		;; DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH
	mov	dword[edx+8],600.
	mov	dword[edx+0C],800.
	mov	dword[edx+100-98],40	;; DDSCAPS_OFFSCREENPLAIN
	mov	eax,[41c8ec]
	mov	ecx,[eax]
	push	41c8f4
	push	edx
	push	eax
	call	dword[ecx+18]	;; CreateSurface
	call	@adjust
	!pad	90

<411060> ; end of .text
; Make a copy of the DirectDrawSurface vtable, pointing BltFast to our own.
@adjust@10:
	push	eax
	push	esi
	push	edi
	mov	eax,[41c8f0]
	mov	esi,[eax]
	mov	edi,@vtable
	mov	[eax],edi
	mov	eax,[esi+1c]
	mov	[@ddBltFast],eax
	mov	ecx,49.
	rep	movsd
	mov	dword[@vtable+1c],@BltFast
	pop	edi
	pop	esi
	pop	eax
	ret

; Set destination according to our centered window position.
@BltFast@10:
	mov	eax,[@x]
	mov	ecx,[@y]
	mov	[esp+8],eax
	mov	[esp+0C],ecx
	jmp	dword[@ddBltFast]

@zSetAppCompatData@4: "SetAppCompatData\0"
@zDDraw@4:	"ddraw.dll\0"

<41df28> ; end of .data
@x:	dd	0
@y:	dd	0
@ddBltFast: dd	0
@vtable:
